package com.gkutiel.github.flip.graph;

import java.util.UUID;

public class Graph {
	private final Db db;

	public Graph(final String folder) {
		db = new Db(folder);
	}

	public Edge addEdge(final String v1, final String v2, final String label) {
		db.addEdge(v1, v2, label);
		return new Edge(v1, v2, label, db);
	}

	public Edge addEdge(final Vertex v1, final Vertex v2, final String label) {
		return addEdge(v1.getId(), v2.getId(), label);
	}

	public Vertex addVertex() {
		return addVertex(UUID.randomUUID().toString());
	}

	public Vertex addVertex(final String id) {
		db.addVertex(id);
		return new Vertex(id, db);
	}

	void delEdge(final String v1, final String v2, final String label) {
		db.delEdge(v1, v2, label);
	}

	void delVertex(final String id) {
		db.delVertex(id);
	}

	public Vertex getVertex(final String id) {
		return new Vertex(id, db);
	}

	public Iterable<Vertex> getVertices() {
		return db.getVertices();
	}
}
